Package: GlarmaVarSel
Type: Package
Title: Variable Selection in Sparse GLARMA Models
Version: 1.0
Date: 2021-09-15
Author: M. Gomtsyan, C. Levy-Leduc, S. Ouadah, L. Sansonnet
Maintainer: Marina Gomtsyan <marina.gomtsyan@agroparistech.fr>
Description: Performs variable selection in high-dimensional sparse GLARMA models. For further details we refer the reader to the paper Gomtsyan et al. (2020), <arXiv:2007.08623v1>.
License: GPL-2
Depends: R (>= 3.5.0), Matrix, glmnet, stats, ggplot2
VignetteBuilder: knitr
Suggests: knitr, markdown, formatR, doMC
NeedsCompilation: no
Packaged: 2021-09-15 15:26:37 UTC; marina
Repository: CRAN
Date/Publication: 2021-09-16 07:40:02 UTC

NR_gamma <-
function(Y, X, beta0, gamma0, n_iter=100){
  gamma<-gamma0
  new.params<-gamma
  n<-length(Y)
  iter<-1
  eps<-10^-6
  erreur<-1+eps
  
  while((erreur>eps)&&(iter<=n_iter)){
    old.params<-new.params
    res_grad_hess=grad_hess_gamma(Y, X, beta0, gamma)
    hessienne=res_grad_hess[[2]]
    grad=res_grad_hess[[1]]
    res_svd=svd(hessienne)
    U=res_svd$u
    V=res_svd$v
    ind_vp_not_null=which(round(res_svd$d,digits=6)!=0) 
    Lambda=diag(1/res_svd$d[ind_vp_not_null],length(ind_vp_not_null))
    hess_inv=V[,ind_vp_not_null]%*%Lambda%*%t(U[,ind_vp_not_null])
    gamma<-gamma-as.numeric(hess_inv%*%grad)
    
    new.params<-gamma
    
    erreur<-max(abs(new.params-old.params))
    iter<-iter+1
  }
  return(gamma=gamma)
}

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(echo = TRUE, message = FALSE)
library(GlarmaVarSel)
library(ggplot2)
library(formatR)
set.seed(123456)

## ----Y------------------------------------------------------------------------
data(Y)

## ----dimensions, echo=FALSE, eval=TRUE----------------------------------------
n = length(Y)
p = 30

## ----gamma, echo=FALSE, eval=TRUE---------------------------------------------
gamma = c(0.5)

## ----beta, echo=FALSE, eval=TRUE----------------------------------------------
active=c(1,3,17)
beta_t_pos=c(1.73,0.38,-0.64)
beta = rep(0,(p+1))
beta[active] = beta_t_pos

## ----X, echo=FALSE, eval=TRUE-------------------------------------------------
X = matrix(NA,(p+1),n)
f = 1/0.7
for(t in 1:n){X[,t]<-c(1,cos(2*pi*(1:(p/2))*t*f/n),sin(2*pi*(1:(p/2))*t*f/n))}

## ----initialization-----------------------------------------------------------
gamma0 = c(0)

glm_pois<-glm(Y~t(X)[,2:(p+1)],family = poisson)
beta0<-as.numeric(glm_pois$coefficients)

## ----gammaEst-----------------------------------------------------------------
gamma_est_nr = NR_gamma(Y, X, beta0, gamma0, n_iter=100)
gamma_est_nr

## ----variableSelection, tidy=TRUE, tidy.opts=list(width.cutoff=60)------------
result = variable_selection(Y, X, gamma0, k_max=2, n_iter=100, method="min", nb_rep_ss=1000, threshold=0.7, parallel=FALSE, nb.cores=1)
beta_est = result$beta_est
Estim_active = result$estim_active
gamma_est = result$gamma_est

## ----print, echo=FALSE, eval=TRUE---------------------------------------------
cat("Estimated active coefficients: ", Estim_active, "\n")
cat("Estimated gamma: ", gamma_est, "\n")

## ----plot, fig.width=6, fig.height=4, tidy=TRUE, tidy.opts=list(width.cutoff=54)----
#First, we make a dataset of estimated betas
beta_data = data.frame(beta_est)
colnames(beta_data)[1] <- "beta"
beta_data$Variable = seq(1, (p+1), 1)
beta_data$y = 0
beta_data = beta_data[beta_data$beta!=0,]
#Next, we make a dataset of true betas
beta_t_data = data.frame(beta)
colnames(beta_t_data)[1] <- "beta"
beta_t_data$Variable = seq(1, (p+1), 1)
beta_t_data$y = 0
beta_t_data = beta_t_data[beta_t_data$beta!=0,]
#Finally, we plot the result
plot = ggplot()+
  geom_point(data = beta_data, aes(x=Variable, y=y, color=beta), pch=16, size=5, stroke = 2)+
  geom_point(data= beta_t_data, aes(x=Variable, y=y, color=beta), pch=4, size=6, stroke = 2)+
  scale_color_gradient2(name=expression(hat(beta)), midpoint=0, low="steelblue", mid = "white", high ="red")+
  scale_x_continuous(breaks=c(1, seq(10, (p+1), 10)), limits=c(0, (p+1)))+
  scale_y_continuous(breaks=c(), limits=c(-1, 1))+
  theme(legend.title = element_text(color = "black", size = 12, face="bold"), legend.text = element_text(color = "black", size = 10))+
  theme(axis.text.x = element_text(angle = 90), axis.text=element_text(size=10), axis.title=element_text(size=10,face="bold"), axis.title.y=element_blank())
plot

variable_selection <-
function(Y, X, gamma0, k_max=2, n_iter=100, method="min", nb_rep_ss=1000,threshold=0.8, parallel=FALSE, nb.cores=1)
{
  search_non_null=function(x)
  {
    ind=as.numeric(which(x!=0))
    return(ind)
  }
  n=length(Y)
  p=dim(X)[1]-1
  q=length(gamma0)
  
  if((p+1)<n){
    glm_pois<-glm(Y~t(X)[,2:(p+1)],family = poisson)
    beta0<-as.numeric(glm_pois$coefficients)
  }else{
    cv_lambda<-cv.glmnet(t(X), Y, family = "poisson", alpha = 1)$lambda.min
    glm_pois<-glmnet(t(X), Y, family = "poisson", alpha = 1, lambda=cv_lambda)
    beta0<-as.numeric(glm_pois$beta)
    beta0[1] = as.numeric(glm_pois$a0)
  }
  gamma_est=NR_gamma(Y, X, beta0, gamma0, n_iter)
  
  for(k in 1:k_max)
  {
    grad_hess_res_est=grad_hess_beta(Y, X, beta0, gamma_est)
    Gradient<-grad_hess_res_est[[1]][1:(p+1)]
    Hessienne<-grad_hess_res_est[[2]]
    
    res_svd=svd(-Hessienne) 
    U=res_svd$u
    ind_vp_not_null=which(round(res_svd$d,digits=6)!=0)
    
    Lambda_rac=diag(sqrt(res_svd$d[ind_vp_not_null])) 
    Lambda_rac_inv=diag(1/sqrt(res_svd$d[ind_vp_not_null]))
    Y_eta=Lambda_rac_inv%*%t(U[,ind_vp_not_null])%*%Gradient+Lambda_rac%*%t(U[,ind_vp_not_null])%*%beta0
    X_eta=Lambda_rac%*%t(U[,ind_vp_not_null])
    
    if(method=='fast'){
      beta_all_lambda=glmnet(X_eta,Y_eta,alpha=1,family = "gaussian")$beta
      
      mat_ind_active=apply(beta_all_lambda,2,FUN = search_non_null)
      position_active=rep(0,(p+1))
      for (i in 1:length(mat_ind_active)){
        position_active[mat_ind_active[[i]]]=position_active[mat_ind_active[[i]]]+1
      }
      freq=position_active/(length(mat_ind_active)-1)
    }else if(method=='cv'){
      lambda_cv=cv.glmnet(X_eta,Y_eta,family="gaussian",alpha=1,parallel=TRUE)$lambda.min
      res.cum = rep(0,(p+1))
      b_sort_matrix = matrix(NA, nrow = nb_rep_ss, ncol = floor((p+1)/2))
      for(j in 1:nb_rep_ss){
        b_sort_matrix[j,] <- sort(sample(1:(p+1),floor((p+1)/2)))
      }
      for(j in 1:nb_rep_ss){
        b_sort = b_sort_matrix[j,]
        resultat_glmnet=glmnet(X_eta[b_sort,],Y_eta[b_sort],family="gaussian",alpha=1,lambda=lambda_cv)
        ind_glmnet=which(as.numeric(resultat_glmnet$beta)!=0)
        res.cum = res.cum + tabulate(ind_glmnet,(p+1))
      }
      freq=res.cum/nb_rep_ss
    }else{
      all_lambda=cv.glmnet(X_eta,Y_eta,family="gaussian",alpha=1,parallel=parallel)$lambda
      lambda_min = c(min(all_lambda))
      res.cum = rep(0,(p+1))
      b_sort_matrix = matrix(NA, nrow = nb_rep_ss, ncol = floor((p+1)/2))
      for(j in 1:nb_rep_ss){
        b_sort_matrix[j,] <- sort(sample(1:(p+1),floor((p+1)/2)))
      }
      for(j in 1:nb_rep_ss){
        b_sort = b_sort_matrix[j,]
        resultat_glmnet=glmnet(X_eta[b_sort,],Y_eta[b_sort],family="gaussian",alpha=1,lambda=lambda_min)
        ind_glmnet=which(as.numeric(resultat_glmnet$beta)!=0)
        res.cum = res.cum + tabulate(ind_glmnet,(p+1))
      }
      freq=res.cum/nb_rep_ss
    }
    
    Estim_active=which(freq>=threshold)
    
    beta_est=rep(0,(p+1))
    if(length(Estim_active) == 1){
      glm_pois<-glm(Y~t(X)[,Estim_active]-1,family = poisson)
      beta_est[Estim_active]<-as.numeric(glm_pois$coefficients)
    }else if((length(Estim_active)<n) & (rankMatrix(t(X)[,Estim_active])[1]==length(Estim_active))){
      glm_pois<-glm(Y~t(X)[,Estim_active]-1,family = poisson)
      beta_est[Estim_active]<-as.numeric(glm_pois$coefficients)
    }else{
      lambda_cv<-cv.glmnet(t(X)[,Estim_active], Y, family = "poisson", alpha = 0)$lambda.min
      glm_pois<-glmnet(t(X)[,Estim_active], Y, family = "poisson", alpha = 0, lambda=lambda_cv)
      beta_est[Estim_active]<-as.numeric(glm_pois$beta)
      if((1%in% Estim_active)==TRUE){
        beta_est[1]=as.numeric(glm_pois$a0)
      }
    }
    gamma_est=NR_gamma(Y, X, beta_est, gamma0, n_iter)
    gamma0 = gamma_est
    beta0=beta_est
    
  }
  return(list(estim_active=Estim_active,beta_est=beta_est,gamma_est=gamma_est))
}

  grad_hess_gamma <-
  function(Y, X, beta0, gamma0)
  {
    mu<-numeric(n) 
    E<-numeric(n) 
    Z<-numeric(n) 
    W<-numeric(n) 
    q<-length(gamma0)
    p<-length(X[,1])-1
    n<-length(Y)
    
    grad_W=matrix(0,nrow=q,ncol=n)
    hess_W_liste=list()
    hess_L_gamma=matrix(0,ncol=q,nrow=q)
    
    Z[1]=0
    W[1]=beta0%*%X[,1]
    mu[1]=exp(W[1])
    E[1]=Y[1]/mu[1]-1
    hess_W_liste[[1]]=matrix(0,ncol=q,nrow=q)
    
    for (t in 2:n)
    {
      hess_W_liste[[t]]=matrix(NA,ncol=q,nrow=q)
      jsup=min(q,(t-1))
      W[t]=beta0%*%X[,t]+sum(gamma0[1:jsup]*E[(t-1):(t-jsup)])
      for (l in 1:q)
      {
        if (l<=jsup) 
        {
          grad_W[l,t]=E[(t-l)]-sum(gamma0[1:jsup]*(1+E[(t-1):(t-jsup)])*grad_W[l,(t-1):(t-jsup)])
        }
        for (m in l:q)
        {
          if (m+l<t) 
          {
            A1=-(1+E[(t-l)])*grad_W[m,(t-l)]
            A2=-(1+E[(t-m)])*grad_W[l,(t-m)]
          }
          else 
          {
            A1=0
            A2=0
          }
          A=A1+A2
          B=-(1+E[(t-1):(t-jsup)])*grad_W[l,(t-1):(t-jsup)]*grad_W[m,(t-1):(t-jsup)]
          C=(1+E[(t-1):(t-jsup)])*as.numeric((lapply(hess_W_liste[((t-1):(t-jsup))],'[',l,m)))
          hess_W_liste[[t]][l,m]=A-sum(gamma0[1:jsup]*(B+C))
        }
      }
      mu[t]=exp(W[t])
      E[t]=Y[t]/mu[t]-1
      
      terme1_hess=hess_W_liste[[t]]*(Y[t]-exp(W[t]))
      terme2_hess=exp(W[t])*(grad_W[,t]%*%t(grad_W[,t]))
      hess_L_gamma=hess_L_gamma+terme1_hess-terme2_hess
    }
    hess_L_gamma[lower.tri(hess_L_gamma)]=hess_L_gamma[upper.tri(hess_L_gamma)]
    grad_L_gamma=grad_W%*%(Y-exp(W))
    return(list(grad_L_gamma = grad_L_gamma, hess_L_gamma=hess_L_gamma))
  }

grad_hess_beta <-
function(Y, X, beta0, gamma0)
{
  mu<-numeric(n) 
  E<-numeric(n) 
  Z<-numeric(n) 
  W<-numeric(n) 
  q<-length(gamma0)
  p<-length(X[,1])-1
  n<-length(Y)
  
  grad_W_beta=matrix(NA,nrow=(p+1),ncol=n)
  hess_W_beta_liste=list()
  hess_L_beta=matrix(0,ncol=(p+1),nrow=(p+1))
  
  Z[1]=0
  W[1]=beta0%*%X[,1]
  mu[1]=exp(W[1])
  E[1]=Y[1]/mu[1]-1
  hess_W_beta_liste[[1]]=matrix(0,ncol=(p+1),nrow=(p+1))
  grad_W_beta[,1]=X[,1]
  
  for (t in 2:n)
  {
    hess_W_beta_liste[[t]]=matrix(NA,ncol=(p+1),nrow=(p+1))
    jsup=min(q,(t-1))
    W[t]=beta0%*%X[,t]+sum(gamma0[1:jsup]*E[(t-1):(t-jsup)])
    for (k in 1:(p+1))
    {
      grad_W_beta[k,t]=X[k,t]-sum(gamma0[1:jsup]*(1+E[(t-1):(t-jsup)])*grad_W_beta[k,(t-1):(t-jsup)])
      
      for (j in k:(p+1))
      {
        B=(1+E[(t-1):(t-jsup)])*grad_W_beta[k,(t-1):(t-jsup)]*grad_W_beta[j,(t-1):(t-jsup)]
        C=-(1+E[(t-1):(t-jsup)])*as.numeric((lapply(hess_W_beta_liste[((t-1):(t-jsup))],'[',k,j)))
        hess_W_beta_liste[[t]][k,j]=sum(gamma0[1:jsup]*(B+C))
      }
    }
    mu[t]=exp(W[t])
    E[t]=Y[t]/mu[t]-1
    
    terme1_hess=hess_W_beta_liste[[t]]*(Y[t]-exp(W[t]))
    terme2_hess=exp(W[t])*(grad_W_beta[,t]%*%t(grad_W_beta[,t]))
    hess_L_beta=hess_L_beta+terme1_hess-terme2_hess
  }
  hess_L_beta[lower.tri(hess_L_beta)]=hess_L_beta[upper.tri(hess_L_beta)]
  grad_L_beta=grad_W_beta%*%(Y-exp(W))
  return(list(grad_L_beta=grad_L_beta, hess_L_beta=hess_L_beta))
}

\name{GlarmaVarSel-package}
\alias{GlarmaVarSel-package}
\alias{GlarmaVarSel}
\docType{package}
\title{
\packageTitle{GlarmaVarSel}
}
\description{
GlarmaVarSel consists of four functions: "variable_selection.R", "grad_hess_beta.R", "grad_hess_gamma.R" and "NR_gamma.R"
For further information on how to use these functions, 
we refer the reader to the vignette of the package.
}
\details{
GlarmaVarSel consists of four functions: "variable_selection.R", "grad_hess_beta.R", "grad_hess_gamma.R" and "NR_gamma.R"
For further information on how to use these functions, 
we refer the reader to the vignette of the package.
}
\author{
Marina Gomtsyan, Celine Levy-Leduc, Sarah Ouadah, Laure Sansonnet

Maintainer: Marina Gomtsyan <marina.gomtsyan@agroparistech.fr>
}
\references{
M. Gomtsyan et al. "Variable selection in sparse GLARMA models", arXiv:2007.08623v1
}
\keyword{package}
\examples{
n=50
p=30
X = matrix(NA,(p+1),n)
f = 1/0.7
for(t in 1:n){X[,t]<-c(1,cos(2*pi*(1:(p/2))*t*f/n),sin(2*pi*(1:(p/2))*t*f/n))}
gamma0 = c(0)
data(Y)
result = variable_selection(Y, X, gamma0, k_max=2, n_iter=100, method="min",
nb_rep_ss=1000, threshold=0.7, parallel=FALSE, nb.cores=1)
beta_est = result$beta_est
Estim_active = result$estim_active
gamma_est = result$gamma_est    
}

\name{NR_gamma}
\alias{NR_gamma}
\title{
Newton-Raphson method for estimation of gamma
}
\description{
This function estimates gamma with Newton-Raphson method
}
\usage{
NR_gamma(Y, X, beta0, gamma0, n_iter)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{Y}{
Observation matrix
}
  \item{X}{
Design matrix
} 
  \item{beta0}{
Initial beta vector
}
  \item{gamma0}{
Initial gamma vector
}
  \item{n_iter}{
Number of iterations of the algorithm. Default=100
}
}
\value{
\item{gamma}{
Estimated gamma vector
}
}
\references{
M. Gomtsyan et al. "Variable selection in sparse GLARMA models", arXiv:2007.08623v1
}
\author{
Marina Gomtsyan, Celine Levy-Leduc, Sarah Ouadah, Laure Sansonnet

Maintainer: Marina Gomtsyan <marina.gomtsyan@agroparistech.fr>
}
\examples{
n=50
p=30
X = matrix(NA,(p+1),n)
f = 1/0.7
for(t in 1:n){X[,t]<-c(1,cos(2*pi*(1:(p/2))*t*f/n),sin(2*pi*(1:(p/2))*t*f/n))}
gamma0 = c(0)
data(Y)
glm_pois<-glm(Y~t(X)[,2:(p+1)],family = poisson)
beta0<-as.numeric(glm_pois$coefficients)
gamma_est = NR_gamma(Y, X, beta0, gamma0, n_iter=100)
}

\name{Y}
\alias{Y}
\docType{data}
\title{
Observation matrix Y
}
\description{
An example of observation matrix
}
\usage{data("Y")}
\format{
  The format is:
 num [1:50] 11 8 3 3 3 4 4 4 3 1 ...
}
\references{
M. Gomtsyan et al. "Variable selection in sparse GLARMA models", arXiv:2007.08623v1
}
\examples{
data(Y)
}

\name{variable_selection}
\alias{variable_selection}
\title{
Variable selection
}
\description{
This function performs variable selection, estimates a new vector beta and a new vector gamma
}
\usage{
variable_selection(Y, X, gamma0, k_max = 2, n_iter = 100, method = "min", 
  nb_rep_ss = 1000, threshold = 0.8, parallel = FALSE, nb.cores = 1)
}
\arguments{
  \item{Y}{
Observation matrix
}
  \item{X}{
Design matrix
}
  \item{gamma0}{
Initial gamma vector
}
  \item{k_max}{
Number of iteration to repeat the whole algorithm
}
  \item{n_iter}{
Number of iteration for Newton-Raphson algorithm
}
  \item{method}{
Stability selection method: "fast", "min" or "cv". In "min" the smallest lambda is chosen, in "cv" cross-validation lambda is chosen for stability selection. "fast" is a fater stability selection approach. The default is "min"
}
  \item{nb_rep_ss}{
Number of replications in stability selection step. The default is 1000
}
  \item{threshold}{
Threshold for stability selection. The default is 0.9
}
  \item{parallel}{
Whether to parallelize stability selection step or not. The default is FALSE
}
  \item{nb.cores}{
Number of cores for parallelization. The default is 1
}
}
\value{
\item{estim_active }{Estimated active coefficients}
\item{beta_est}{Vector of estimated beta values}
\item{gamma_est}{Vector of estimated gamma values}
%% ...
}
\references{
M. Gomtsyan et al. "Variable selection in sparse GLARMA models", arXiv:2007.08623v1
}
\author{
Marina Gomtsyan, Celine Levy-Leduc, Sarah Ouadah, Laure Sansonnet

Maintainer: Marina Gomtsyan <marina.gomtsyan@agroparistech.fr>
} 
\examples{
n=50
p=30
X = matrix(NA,(p+1),n)
f = 1/0.7
for(t in 1:n){X[,t]<-c(1,cos(2*pi*(1:(p/2))*t*f/n),sin(2*pi*(1:(p/2))*t*f/n))}
gamma0 = c(0)
data(Y)
result = variable_selection(Y, X, gamma0, k_max=2, n_iter=100, method="min",
nb_rep_ss=1000, threshold=0.7, parallel=FALSE, nb.cores=1)
beta_est = result$beta_est
Estim_active = result$estim_active
gamma_est = result$gamma_est    
}
